//
//  BTSViewController.m
//  BLE-Tutorial
//
//  Created by Ole Andreas Torvmark on 3/2/12.
//  Copyright (c) 2012 ST alliance AS. All rights reserved.
//

#import "BTSViewController.h"

@implementation BTSViewController
@synthesize connectButton;
@synthesize scanButton;
@synthesize dbgText;

@synthesize window = _window;
@synthesize CBC;
@synthesize peripheral;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    NSLog(@"Initializing BLE");
    [dbgText setText:[NSString stringWithFormat:@"%@Initializing BLE\r\n",dbgText.text]];
    self.CBC = [CBCMCtrl alloc];
    if (self.CBC) {
        self.CBC.cBCM = [[CBCentralManager alloc] initWithDelegate:self.CBC queue:nil]; 
        self.CBC.delegate = self;
    }
}

- (void)viewDidUnload
{
    [self setScanButton:nil];
    [self setDbgText:nil];
    [self setConnectButton:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

- (IBAction)scanButtonPress:(id)sender {
    if (self.CBC.cBReady) {
        // BLE HW is ready start scanning for peripherals now.
        NSLog(@"Button pressed, start scanning ...");
        [self.scanButton setTitle:@"Scanning ..." forState:UIControlStateNormal];
        [self.CBC.cBCM scanForPeripheralsWithServices:nil options:nil];
    }
}

- (IBAction)connectButtonPress:(id)sender {
    if(self.peripheral) {
        if(!self.peripheral.isConnected) {
            [self.CBC.cBCM connectPeripheral:self.peripheral options:nil];
            [self.connectButton setTitle:@"Disconnect ..." forState:UIControlStateNormal];
        }
        else {
            [self.CBC.cBCM cancelPeripheralConnection:self.peripheral];
            [self.connectButton setTitle:@"Connect ..." forState:UIControlStateNormal];
        }
    }
}

- (void) updateLog:(NSString *)text {
    [dbgText setText:[NSString stringWithFormat:@"%@%@\r\n",dbgText.text,text]];
}



- (void) foundPeripheral:(CBPeripheral *)p {
    [connectButton setEnabled:true];
    self.peripheral = p;
}

@end
